#
# Preferences change for tkabc.
#
# Copyright (C) 1999-2005, Jean-Franois Moine.
#
# Contact: mailto:moinejf@free.fr
# Original site: http://moinejf.free.fr/
#

proc f-raise {p} {
# raise a preference frame
    set f .pref.$p
    set pl [pack slaves .pref]
    if {[llength $pl] > 2} {
	foreach w $pl {
	    switch $w {
		.pref.m - .pref.c - .pref.w {}
		default {
		    pack forget $w
		}
	    }
	}
    }
    pack $f -side left
    #fixme: set colors
}

proc pref-change {} {
# apply the new preferences
    global lang opt opttmp
    if {![file readable $opttmp(lang)]} {
	tk_messageBox -type ok -icon error -title $lang(bad_file) \
		-message [format $lang(lang_err) $fn]
	set opttmp(lang) $opt(lang)
    }
    array set opt [array get opttmp]
    unset opttmp
    destroy .pref
    pref-save
}

proc pref-edit {} {
# edit the preferences
    global font lang opt opttmp pref
    set top .pref
    if {[winfo exists $top]} {
        raise $top
        focus $top.m
	#fixme: focus on 1st entry of current page
        return
    }
    array set opttmp [array get opt]
    toplevel $top
    wm title $top $lang(m_pref)
    wm geometry $top 500x200
   # warning
    set w $top.w
    label $w -text $lang(p_warn)
#	-width 50
    pack $w -side top
    # menu on the left
    set pref cmd
    set m $top.m
    frame $m -borderwidth 18
    foreach p [list cmd clr misc scr midi] {
	radiobutton $m.$p -indicatoron 0 \
		-selectcolor $opt(chg_bg) -background $opt(ent_bg) \
		-variable pref -value $p -text $lang(p_$p) \
		-command [list f-raise $p]
	pack $m.$p -side top -fill x
	frame $top.$p
	label $top.$p.l -text $lang(p_$p)
	pack $top.$p.l -side top
    }
    # commands
    set label_w 14
    set entry_w 30
    set button_w 7
    set c $top.cmd
    frame $c.ps
    label $c.ps.l -width $label_w -anchor e -text {abc(m)2ps:}
    entry $c.ps.e -relief sunken -width $entry_w -background $opt(ent_bg) \
	-textvariable opttmp(abc2ps)
    button $c.ps.b -width $button_w -padx 1 -text browse \
	-command {setpath abc2ps}
    pack $c.ps.l $c.ps.e $c.ps.b -side left
    frame $c.psa
    label $c.psa.l -width $label_w -anchor e -text {abc(m)2ps args:}
    entry $c.psa.e -relief sunken -width $entry_w -background $opt(ent_bg) \
	-textvariable opttmp(abc2ps-args)
    label $c.psa.b -width $button_w -text {}
    pack $c.psa.l $c.psa.e $c.psa.b -side left
    frame $c.gv
    label $c.gv.l -width $label_w -anchor e -text $lang(p_gv)
    entry $c.gv.e -relief sunken -width $entry_w -background $opt(ent_bg) \
	-textvariable opttmp(ghostview)
    button $c.gv.b -width $button_w -padx 1 -text browse \
	-command {setpath ghostview}
    pack $c.gv.l $c.gv.e $c.gv.b -side left
    frame $c.d
    label $c.d.l -width $label_w -anchor e -text $lang(p_tmp)
    entry $c.d.e -relief sunken -width $entry_w -background $opt(ent_bg) \
	-textvariable opttmp(tmpdir)
    button $c.d.b -width $button_w -padx 1 -text browse \
	-command {setpath tmpdir}
    pack $c.d.l $c.d.e $c.d.b -side left
    pack $c.ps $c.psa $c.gv $c.d -side top
    # colors
    set c $top.clr
    frame $c.bg
    label $c.bg.l -width $label_w -anchor e -text $lang(p_bg)
    entry $c.bg.e -relief sunken -width $entry_w -background $opt(ent_bg) \
	-textvariable opttmp(bg)
    pack $c.bg.l $c.bg.e -side left
    frame $c.cbg
    label $c.cbg.l -width $label_w -anchor e -text $lang(p_chc)
    entry $c.cbg.e -relief sunken -width $entry_w -background $opt(ent_bg) \
	-textvariable opttmp(chg_bg)
    pack $c.cbg.l $c.cbg.e -side left
    frame $c.ncbg
    label $c.ncbg.l -width $label_w -anchor e -text $lang(p_nchc)
    entry $c.ncbg.e -relief sunken -width $entry_w -background $opt(ent_bg) \
	-textvariable opttmp(nochg_bg)
    pack $c.ncbg.l $c.ncbg.e -side left
    frame $c.vc
    label $c.vc.l -width $label_w -anchor e -text $lang(p_vc)
    entry $c.vc.e -relief sunken -width $entry_w -background $opt(ent_bg) \
	-textvariable opttmp(v_color)
    pack $c.vc.l $c.vc.e -side left
    pack $c.bg $c.cbg $c.ncbg $c.vc -side top
    # misc
    set c $top.misc
    frame $c.lg
    label $c.lg.l -width $label_w -anchor e -text $lang(p_lgf)
    entry $c.lg.e -relief sunken -width $entry_w -background $opt(ent_bg) \
	-textvariable opttmp(lang)
    pack $c.lg.l $c.lg.e -side left
    frame $c.d
    label $c.d.l -width $label_w -anchor e -text $lang(p_detail)
    entry $c.d.e -relief sunken -width $entry_w -background $opt(ent_bg) \
	-textvariable opttmp(detail)
    pack $c.d.l $c.d.e -side left
    frame $c.t
    label $c.t.l -width $label_w -anchor e -text $lang(p_tempo)
    entry $c.t.e -relief sunken -width $entry_w -background $opt(ent_bg) \
	-textvariable opttmp(tempo)
    pack $c.t.l $c.t.e -side left
    pack $c.lg $c.d $c.t -side top
    # screen
    set c $top.scr
    frame $c.h
    label $c.h.l -width $label_w -anchor e -text $lang(p_hght)
    entry $c.h.e -relief sunken -width $entry_w -background $opt(ent_bg) \
	-textvariable opttmp(screen-h)
    pack $c.h.l $c.h.e -side left
    frame $c.w
    label $c.w.l -width $label_w -anchor e -text $lang(p_wid)
    entry $c.w.e -relief sunken -width $entry_w -background $opt(ent_bg) \
	-textvariable opttmp(screen-w)
    pack $c.w.l $c.w.e -side left
    pack $c.h $c.w -side top
    # midi
    set c $top.midi
    frame $c.d
    label $c.d.l -width $label_w -anchor e -text $lang(p_midin)
    entry $c.d.e -relief sunken -width $entry_w -background $opt(ent_bg) \
	-textvariable opttmp(midiin)
    pack $c.d.l $c.d.e -side left
    frame $c.t
    label $c.t.l -width $label_w -anchor e -text $lang(p_midout)
    entry $c.t.e -relief sunken -width $entry_w -background $opt(ent_bg) \
	-textvariable opttmp(midiout)
    pack $c.t.l $c.t.e -side left
    pack $c.d $c.t -side top
    # window control on the bottom
    set c $top.c
    frame $c
    button $c.ok -text {OK} -width 8 \
        -command pref-change
    button $c.abort -text $lang(cancel) -width 8 \
        -command [list destroy $top]
    pack $c.ok $c.abort -side left -padx 10
# -fill x -expand 1
#
    pack $m -side left
    pack $c -side bottom
    f-raise cmd
}

proc pref-save {} {
# save the preferences
    global opt tcl_platform
    if {[string compare $tcl_platform(platform) unix] == 0} {
	set fn "~/.tkabcrc"
	set fnbak $fn.BAK
    } else {
	set fn "~/tkabc.rc"
	set fnbak "~/tkabc.bak"
    }
    if {![catch {open $fn r} fd]} {
	set old [split [read $fd [file size $fn]] "\n"]
	close $fd
	file rename -force $fn $fnbak
	set s [lsearch $old {# USER SETTINGS}]
	set e [lsearch $old {# END OF USER SETTINGS}]
	if {$s >= 0 && $e > $s} {
	    set old [lreplace $old $s $e]
	}
    } else {
	set old {}
    }
    if {[catch {open $fn w} fd]} {
	tk_messageBox -type ok -icon error -title $lang(bad_file) \
		-message [format $lang(wr_err) $fn]
	return
    }
    puts -nonewline $fd [join $old "\n"]
    puts $fd "# USER SETTINGS
# everything between here and the END OF USER SETTINGS comment line
# will be rewritten on a Preference Save
array set opt {"
    foreach v [lsort [array names opt]] {
	if {[string length $opt($v)] > 0 && [string first " " $opt($v)] < 0} {
	    puts $fd "\t$v $opt($v)"
	} else {
	    puts $fd "\t$v {$opt($v)}"
	}
    }
    puts $fd "}
# END OF USER SETTINGS"
    close $fd
}

proc setpath {name} {
# browse a file name
    global opttmp
    set filedir [file dirname $opttmp($name)]
    set filename [tk_getOpenFile -initialdir $filedir]
    if {[string length $filename] != 0} {
	set opttmp($name) $filename
    }
}
